;; -*- Mode: Lisp; Package: USER -*-
;;;
;;; eblook.l - an eblook client
;;;

;; Author: FUJIWARA Teruyoshi <tf at dsl.gr.jp>
;; Created: Nov 09, 2005
;; Revised: Jul 06, 2008

;;; Commentary (written in Japanese)

;;
;; <Tv>
;;  lisp ́Cdqc[ł eblook gCxyzzy 
;; ߂̂̂łD̂ƂCɂƂĕKvŏ̋@\
;; Ă܂D
;;
;; mF́C
;;   - xyzzy 0.2.2.235
;;   - pYEPWING݊`ɕϊ (FreePWING gĕϊ)
;; ōsȂĂ܂D̊œǂ͂킩܂D
;; 
;; <O>
;; Windows p eblook сCeblook ΉĂdq
;; pӂĂDł͏ڂ͂܂񂪁CLURL
;; QlɂȂł傤D
;;
;; Eeblook: http://openlab.ring.gr.jp/edict/eblook/
;; EdqI[v{: http://openlab.jp/edict/
;; EEBCu: http://www.sra.co.jp/people/m-kasahr/eb/
;;
;; <xyzzy ̐ݒ@>
;; 1. ̃t@C xyzzy  site-lisp tH_(܂ load-path ʂ
;;    tH_)ɒuD
;;
;; 2. ~/.xyzzy Ɉȉ̐ݒǉDL[oCh͍D݂ɍ킹ĕς
;; (autoload 'eblook "eblook" t)
;; (autoload 'eblook-pickup-search "eblook" t)
;; (global-set-key '(#\C-x #\w) 'eblook-pickup-search)
;; (setq *eblook-command* "d:/usr/bin/eblook.exe")  eblook.exe ̃tpXw
;; (setq *eblook-dictionary-path* "d:/usr/dict/eijiro")  ̂tH_w
;;
;; <@>
;; 1. Ăяo
;;   a. ׂpP̏Ƀ|CguCC-x w (M-x eblook-pickup-search)
;;       eblook [hɓC̉pP܂D
;;   b. M-x eblook
;;       eblook [hɓ܂D
;;
;; 2. L[oCh
;;   ꗗ("*eblook:entry*" obt@)
;;   p, C-p: I(O̍)
;;   n, C-n: I(̍)
;;   RET: \
;;   Xy[X: ʂ̃y[W()
;;   DEL, C-h: ʂ̃y[W(߂)
;;   f: ׂP̓ (~jobt@Ŗ₢킹܂)
;;   q: eblook I
;;
;;   ʕ\("*eblook:content*"obt@)
;;   C-k: J[\ʒuȍ~LOɃRs[
;;
;; <Todo & bugs>
;; - ڈꗗ/ʕ\EBhEɃS~\o邱Ƃ
;; - ̎ւ̑Ή & h
;; - p`͌ɖ߂Ă猟
;; - I entry obt@c(process Ĩ^C~Ȍ܂ЂƂ)D
;; - 摜悤ɂ
;;

;;; Copyright

;; Copyright (C) 2005-2008 FUJIWARA Teruyoshi
;;
;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program; if not, you can either send email to this
;; program's maintainer or write to: The Free Software Foundation,
;; Inc.; 59 Temple Place, Suite 330; Boston, MA 02111-1307, USA.
;;

;;; Code

(provide "eblook")

(export '(*eblook-mode-hook* *eblook-mode-map*
	  *eblook-content-mode-hook* *eblook-content-mode-map*
	  *eblook-prompt* *eblook-ret*
	  *eblook-command* *eblook-dictionary-path*
	  eblook eblook-pickup-search eblook-search))

(defvar *eblook-command* "d:/usr/eblook/eblook.exe")
(defvar *eblook-dictionary-path* "d:/usr/dict/eijiro")

(defvar *eblook-prompt* "eblook> ")
(defvar *eblook-ret* "\n")
(defvar *eblook-entry-buffer* "*eblook:entry*")
(defvar *eblook-content-buffer* "*eblook:content*")

(defconstant *eblook-state-startup* 0)
(defconstant *eblook-state-init* 1)
(defconstant *eblook-state-select-dictionary* 2)
(defconstant *eblook-state-query-word* 3)
(defconstant *eblook-state-view-content* 4)

(defstruct eblook-command (state nil) (command nil))

(defvar *eblook-entry-window* nil)
(defvar *eblook-content-window* nil)
(defvar *eblook-command-queue* nil)

(defvar *eblook-process-buffer* "")

(defvar *eblook-mode-map* nil)
(defvar *eblook-content-mode-map* nil)

(defvar *eblook-mode-hook* nil)
(defvar *eblook-content-mode-hook* nil)

(unless *eblook-mode-map*
  (setq *eblook-mode-map* (make-sparse-keymap))
  (define-key *eblook-mode-map* #\f 'eblook-search)
  (define-key *eblook-mode-map* #\q 'eblook-quit)
  (define-key *eblook-mode-map* #\p 'eblook-previous-line)
  (define-key *eblook-mode-map* #\n 'eblook-next-line)
  (define-key *eblook-mode-map* #\C-n 'eblook-next-line)
  (define-key *eblook-mode-map* #\RET 'eblook-show-content)
  (define-key *eblook-mode-map* #\SPC 'eblook-next-page)
  (define-key *eblook-mode-map* #\DEL 'eblook-previous-page)
  (define-key *eblook-mode-map* #\C-h 'eblook-previous-page))

(unless *eblook-content-mode-map*
  (setq *eblook-content-mode-map* (make-sparse-keymap))
  (define-key *eblook-content-mode-map* #\f 'eblook-search)
  (define-key *eblook-content-mode-map* #\q 'eblook-quit)
  (define-key *eblook-content-mode-map* #\SPC 'eblook-next-page)
  (define-key *eblook-content-mode-map* #\DEL 'eblook-previous-page)
  (define-key *eblook-content-mode-map* #\C-h 'eblook-previous-page)
  (define-key *eblook-content-mode-map* #\C-k 'eblook-copy-line))

(defun eblook ()
  "Lookup dictionary using eblook."
  (interactive)
  (setq *eblook-command-queue* nil)
  (setq *eblook-process-buffer* "")
  
  (put-queue (make-eblook-command :state *eblook-state-startup* :command nil))
  (put-queue (make-eblook-command :state *eblook-state-init* :command "select 1"))
  
  (eblook-setup-window)
  (eblook-setup-entry-buffer)
  (eblook-setup-content-buffer)
  (refresh-screen))

;
; setup functions
;
(defun eblook-mode ()
  "Define major mode for eblook(main window)."
  (setq mode-name "eblook")
  (setq buffer-mode 'eblook-mode)
  (use-keymap *eblook-mode-map*)
  (setq need-not-save t)
  (setq auto-save nil)
  (setq kept-undo-information nil)
  (run-hooks '*eblook-mode-hook*))

(defun eblook-content-mode ()
  "Define major mode for eblook(content window)."
  (setq mode-name "eblook-content")
  (setq buffer-mode 'eblook-content-mode)
  (use-keymap *eblook-content-mode-map*)
  (setq need-not-save t)
  (setq auto-save nil)
  (setq kept-undo-information nil)
  (run-hooks '*eblook-content-mode-hook*))

(defun eblook-setup-window ()
  "Setup windows for eblook"
  (setq *eblook-original-window* (selected-window))
  (setq *eblook-original-buffer* (selected-buffer))

  (split-window)
  (other-window 1)
  (set-buffer (get-buffer-create *eblook-entry-buffer*))
  (setq *eblook-entry-window* (selected-window))
  (erase-buffer (selected-buffer))
  
  (split-window 5)
  (other-window 1)
  (set-buffer (get-buffer-create *eblook-content-buffer*))
  (setq *eblook-content-window* (selected-window))
  (erase-buffer (selected-buffer)))

(defun eblook-setup-entry-buffer ()
  "Setup a buffer for entry selection."
  (set-window *eblook-entry-window*)
  (let ((proc (buffer-process (selected-buffer))))
    (and proc (eq (process-status proc) ':run)
	 (return-from eblook-setup-entry-buffer t)))
  
  (eblook-mode)
  (set-process-filter
   (make-process (concat *eblook-command* " " *eblook-dictionary-path*)
		 :output (selected-buffer))'eblook-filter))

(defun eblook-setup-content-buffer ()
  "Setup a buffer for content view."
  (set-window *eblook-content-window*)
  (set-buffer (get-buffer-create *eblook-content-buffer*))
  (eblook-content-mode)
  (erase-buffer (selected-buffer)))  

;
; Control subprocess
;
(defun eblook-filter (process line)
  "Define a filter for a eblook process."
  (setq *eblook-process-buffer*
	(concat *eblook-process-buffer* line))
  (set-window *eblook-entry-window*)
  (set-buffer (get-buffer-create *eblook-entry-buffer*))
  
  (let ((m (string-matchp *eblook-prompt* *eblook-process-buffer*)))
    (if m (progn
	    (eblook-control
	     (substring *eblook-process-buffer*
			0
			(+ m (length *eblook-prompt*))))
	    (setq *eblook-process-buffer*
		  (substring *eblook-process-buffer*
			     (+ m (length *eblook-prompt*)))))))
  (refresh-screen)
  (if (string-matchp *eblook-prompt* *eblook-process-buffer*)
      (eblook-filter process "")))

(defun eblook-kick-queue-command ()
  "Issue the first command in the queue."
  (if (check-queue)
      (let ((cmd (eblook-command-command (car *eblook-command-queue*))))
	(if cmd (eblook-send-command cmd)))))
    
(defun eblook-send-command (cmd)
  (set-window *eblook-entry-window*)
  (set-buffer (get-buffer-create *eblook-entry-buffer*))
  (let ((process (buffer-process (selected-buffer))))
    (process-send-string process (concatenate 'string cmd *eblook-ret*))))

;
; Control state
;
(defun eblook-control (line)
  "Control internal state according to input from a eblook process."
  (let* ((item (get-queue))
	 (cmd (eblook-command-state item))
	 (arg (eblook-command-command item)))
    (cond
     ((null cmd))
     ((eq cmd *eblook-state-startup*))
     ((eq cmd *eblook-state-init*))
     ((eq cmd *eblook-state-query-word*)
      (eblook-control-query line))
     ((eq cmd *eblook-state-view-content*)
      (eblook-control-content line)))
    (refresh-screen))
  (if (check-queue)
      (eblook-kick-queue-command)))

(defun eblook-control-query (str)
  "A sub-function of eblook-control."
  (set-window *eblook-entry-window*)
  (set-buffer (get-buffer-create *eblook-entry-buffer*))
  (setq buffer-read-only nil)
  (erase-buffer (selected-buffer))
  
  (mapcar (lambda (l)
	    (insert (substitute-string l "[0-9]+:[0-9]+\t" "") "\n"))
	  (butlast (split-string str "\n")))
  (if (eq (point-max) (point-min))
      (insert "No match.\n"))
  (goto-char (point-min))
  (setq buffer-read-only t)
  (eblook-show-content 1)
  (refresh-screen))

(defun eblook-control-content (str)
  "A sub-function of eblook-control."
  (set-window *eblook-content-window*)
  (set-buffer (get-buffer-create *eblook-content-buffer*))
  (setq buffer-read-only nil)
  (erase-buffer (selected-buffer))

  ; an ad-hoc fix to delete garbage string in the content window
  ;(let ((m (string-match *eblook-prompt* str)))
  ;  (if m (setq str (concat (substring str 0 (+ m 1)) "\n"))))
  
  (mapcar (lambda (w)
	    (insert w "\n"))
	  (butlast (split-string str "\n")))
  (goto-char (point-min))
  (setq buffer-read-only t)
  
  (set-window *eblook-entry-window*)
  (set-buffer (get-buffer-create *eblook-entry-buffer*))
  (refresh-screen))

;
; User interaction
;
(defun eblook-pickup-search ()
  "Pick up a string at the point and look it up in the dictoinary."
  (interactive)
  (let ((w (eblook-pickup-word-at-point)))
    (eblook)
    (eblook-search w)))

(defun eblook-pickup-word-at-point ()
  "Pick up a string at the point."
  (interactive)
  (save-excursion
    (let ((begin (progn
		   (skip-syntax-spec-backward  "w_j")
		   (point)))
	  (end (progn
		 (skip-syntax-spec-forward  "w_j")
		 (point))))
      (buffer-substring begin end))))
  
(defun eblook-search (&optional word)
  "Look up a string given as an argument."
  (interactive)
  (setq *eblook-process-buffer* "")

  (let ((w (or word (read-string "Word: "))))
    (put-queue (make-eblook-command
		:state *eblook-state-query-word*
		:command (concat "search " "\"" w "\"")))
    (eblook-kick-queue-command)))

(defun eblook-quit ()
  "Terminate the eblook process, clean-up windows/buffers and quit eblook."
  (interactive)
  (eblook-send-command "quit")
  
  (set-window *eblook-entry-window*)
  (set-buffer (get-buffer-create *eblook-entry-buffer*))
  (let ((proc (buffer-process (selected-buffer))))
    (and proc (eq (process-status proc) ':run)
	 (kill-process proc)))
  (delete-window)
  
  (set-window *eblook-content-window*)
  (delete-window)
  
  ; The entry buffer cannot be deleted because somehow the subprocess remains.
  ;(set-buffer (get-buffer-create *eblook-entry-buffer*))
  ;(delete-buffer (selected-buffer))
  (set-buffer (get-buffer-create *eblook-content-buffer*))
  (delete-buffer (selected-buffer))
  
  (set-buffer *eblook-original-buffer*))

(defun eblook-previous-line ()
  "Go backward in an entry selection."
  (interactive)
  (set-window *eblook-entry-window*)
  (set-buffer (get-buffer-create *eblook-entry-buffer*))
  (previous-line))

(defun eblook-next-line ()
  "Go forward in an entry selection."
  (interactive)
  (set-window *eblook-entry-window*)
  (set-buffer (get-buffer-create *eblook-entry-buffer*))
  (if (save-excursion
	(next-line)
	(let ((p1 (progn (goto-bol) (point)))
	      (p2 (progn (goto-eol) (point))))
	  (not (equal p1 p2))))
      (next-line)))

(defun eblook-show-content (&optional num)
  "Update the content buffer for selection in the entry buffer."
  (interactive)
  (setq *eblook-process-buffer* "")
  (unless (save-excursion
	    (goto-char (point-min))
	    (scan-buffer "No match"))
    (put-queue (make-eblook-command
		:state *eblook-state-view-content*
		:command (concat "content " (format nil "~D" (if num num (current-line-number))))))
    (eblook-kick-queue-command)))

(defun eblook-previous-page ()
  "Scroll up to a previous page in the content buffer."
  (interactive)
  (set-window *eblook-content-window*)
  (set-buffer (get-buffer-create *eblook-content-buffer*))
  (unless (previous-page)
    (if (eblook-previous-line)
	(eblook-show-content)))
  (set-window *eblook-entry-window*)
  (set-buffer (get-buffer-create *eblook-entry-buffer*)))

(defun eblook-next-page ()
  "Scroll down to a next page in the content buffer."
  (interactive)
  (set-window *eblook-content-window*)
  (set-buffer (get-buffer-create *eblook-content-buffer*))
  (unless (next-page)
    (if (eblook-next-line)
	(eblook-show-content)))
  (set-window *eblook-entry-window*)
  (set-buffer (get-buffer-create *eblook-entry-buffer*)))

; Not used (preparation for mode for the content viewer)
(defun eblook-copy-line ()
  "Copy a string from the point to the end of the current line and put it to the kill ring."
  (interactive)
  (save-excursion
    (let ((from (point))
	  (to (progn
		(end-of-line)
		(point))))
      (copy-region-as-kill from to))))
;
; utility functions (queue)
;
(defun put-queue (item)
  "Add an item into the command queue."
  ; debug print
  ;(set-buffer (get-buffer-create "log"))
  ;(insert (format nil "~D ~A" (eblook-command-state item) (eblook-command-command item)) "\n")
  (setq *eblook-command-queue* (nconc *eblook-command-queue* (list item))))

(defun get-queue ()
  "Get an item from the command queue."
  (pop *eblook-command-queue*))

(defun check-queue ()
  "Return t if queue is not empty."
  (> (length *eblook-command-queue*) 0))
